--[[
Group O Matic, 2-21-08 (c). by Bryce Wilbur -- Anyone may use, modify, and/or redistribute this work, provided that this notice remains unmodified. This work may not be sold or included in any for-profit compilations.

0.0.5B (3-16-08)
-The auto-arranger now supports custom user templates, for example to behave differently for BGs or specific boss fights. (see templates.lua if you want to create one)
-Included a sample AV template, which tries to put a healer in each group and separate classes out as much as possible.
-Various code improvements
-When arranging groups, the addon now makes sure that the previous move succeeded before it tries to make another move. This allows the auto-arrange to go faster without risk of problems if you are lagging.
-Fixed a bug that happened if you gave someone else leadership of the raid in the middle of an auto-arrange.
-Possible fix for the "Your group is full" bug in AV
-Added checks for combat, you can't auto-move people in combat.

0.0.3B (3-14-08):
-Expanded GUI.
-Added local talent scan.
-Fixed error when running the auto-arrange as a mage, warlock, rogue or hunter
-Fixed various small bugs
-/gom cancel will now work during talent collection as well as during the actual arrangement process
-GOM now works in Battleground raids

0.0.2B (3-10-08): Added mini-GUI pinned to the raid frame

0.0.1B (3-8-08): initial release

TODO:
*try and figure out SetRaidRosterSelection() -- the bliz raid ui calls that on the id of a person when it starts to move them (my guess is that it just hides the button)
*restore should be disabled if there are no saved raids
*throttle on /rs and /rm ? (possibly using delayedactionqueue)
*group swap (last action should reflect this) don't announce finish if it's set that way either
]]

GrOM_Vars = {
RolesByNameCache = {},
SavedRaidLayouts = {},
AlwaysSure = false,
Silent = false,
ShowGUI = true,
LocalOverridesRemote = false, --old var name, what this==true does now is disable the direct talent check entirely
userTemplateToUse = nil
}

GrOM.Version_String = "0.0.5 Beta"

--set this to 0.xxx for betas
GrOM.Version = 0.0001 -- this should only change if the talent check system is changed (because of a talent patch etc) or if there's some other reason for non-raid leaders to upgrade


GrOM.userTemplates = {}
GrOM.ArrangementFrameUpdateThrottle = 0.3
GrOM.ArrangementFrameBreakMaximum = 1000
GrOM.TalentRequestDelayMinimum = 5.0
GrOM.TalentRequestDelayMaximum = 60.0
GrOM.resetErrorConditionThrottle = 30.0

GrOM.ARRANGE_BREAK = 0

GrOM.InspectTainted = true
GrOM.SaveName = nil

local loc = GrOM.Localization

local roleIndex = {
	["MAIN_TANK"] = 1,
	["TANK"] = 2,
	["TANK_BUFFER"] = 3,
	["HEALER"] = 4,
	["MANA_BATTERY"] = 5,
	["HEAL_BUFFER"] = 6,
	["MELEE_BUFFER"] = 7,
	["RANGE_BUFFER"] = 8,
	["SPELL_BUFFER"] = 9,
	["MELEE_DPS"] = 10,
	["RANGE_DPS"] = 11,
	["SPELL_DPS"] = 12
}

--index maps onto roles above
local defaultClassRoles = {
	["WARRIOR"] = {false, true, false, false, false, false, true, false, false, true, false, false},
	["DRUID"] = {false, false, false, true, false, true, false, false, false, false, false, false},
	["SHAMAN"] = {false, false, false, true, true, false, true, true, true, false, false, false},
	["MAGE"] = {false, false, false, false, false, false, false, false, false, false, false, true},
	["WARLOCK"] = {false, false, true, false, false, false, false, false, false, false, false, true},
	["ROGUE"] = {false, false, false, false, false, false, false, false, false, true, false, false},
	["HUNTER"] = {false, false, false, false, false, false, false, false, false, false, true, false},
	["PRIEST"] = {false, false, false, true, false, false, false, false, false, false, false, false},
	["PALADIN"] = {false, false, true, true, false, false, false, false, false, false, false, false}
}

--if one of these is true, it is true for ALL members of that class, false means SOME OR ALL members of that class do not play that role
local universalClassRoles = {
	["WARRIOR"] = {false, false, false, false, false, false, true, false, false, false, false, false},
	["DRUID"] = {false, false, false, false, false, false, false, false, false, false, false, false},
	["SHAMAN"] = {false, false, false, false, false, true, true, true, true, false, false, false},
	["MAGE"] = {false, false, false, false, false, false, false, false, false, false, false, true},
	["WARLOCK"] = {false, false, false, false, false, false, false, false, false, false, false, true},
	["ROGUE"] = {false, false, false, false, false, false, false, false, false, true, false, false},
	["HUNTER"] = {false, false, false, false, false, false, false, false, false, false, true, false},
	["PRIEST"] = {false, false, false, false, false, false, false, false, false, false, false, false},
	["PALADIN"] = {false, false, false, false, false, false, true, true, true, false, false, false}
}

--these map talents to their closest PRIMARY function...left to right top to bottom by tree
local tank, heal, melee, range, spell = 1, 2, 3, 4, 5
local mainRolesWarrior = {
	{melee,tank,melee,tank,tank,tank,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee},
	{tank,melee,tank,melee,melee,tank,tank,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee},
	{tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank}
}
local mainRolesDruid = {
	{spell,tank,tank,spell,spell,spell,spell,heal,tank,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell},
	{tank,tank,tank,tank,tank,tank,tank,melee,melee,melee,tank,melee,tank,heal,tank,tank,tank,melee,tank,tank,tank},
	{heal,tank,heal,heal,tank,heal,heal,tank,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal}
}
local mainRolesShaman = {
	{spell,spell,spell,heal,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,heal,spell,spell},
	{melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee}, --god damn this tree sucks...i'm not even going to bother reading all the descriptions -.-
	{heal,heal,heal,heal,heal,spell,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal,heal}
}
local mainRolesMage = false --always spell dps

local mainRolesWarlock = false --always spell dps

local mainRolesRogue = false --always melee dps

local mainRolesHunter = false --always ranged dps

local mainRolesPriest = {
	{heal,spell,heal,heal,heal,heal,heal,heal,heal,spell,spell,spell,heal,heal,spell,spell,spell,spell,spell,spell,spell,spell},
	{heal,heal,heal,spell,spell,heal,spell,heal,spell,heal,spell,heal,heal,heal,spell,heal,heal,heal,spell,heal,heal},
	{spell,spell,spell,spell,spell,spell,spell,spell,heal,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell,spell}
}
local mainRolesPaladin = {
	{melee,heal,heal,melee,heal,heal,heal,heal,heal,heal,tank,heal,heal,heal,heal,heal,heal,tank,heal,heal},
	{tank,tank,tank,heal,tank,heal,tank,tank,tank,tank,tank,spell,tank,tank,tank,tank,tank,tank,tank,tank,tank,tank},
	{melee,melee,melee,melee,tank,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,melee,tank,melee,melee}
}

local talentsToMainRolesByClass = {
	["WARRIOR"] = mainRolesWarrior,
	["DRUID"] = mainRolesDruid,
	["SHAMAN"] = mainRolesShaman,
	["MAGE"] = mainRolesMage,
	["WARLOCK"] = mainRolesWarlock,
	["ROGUE"] = mainRolesRogue,
	["HUNTER"] = mainRolesHunter,
	["PRIEST"] = mainRolesPriest,
	["PALADIN"] = mainRolesPaladin
}	

local talentsToSpecialRolesByClass = {
	["WARRIOR"] = {
		{},
		{[8]="MELEE_BUFFER"}, -- Commanding Presence -- Only considered if the warrior isn't placed in a tanking group
		{}
	},
	["DRUID"] = {
		{[18]="SPELL_BUFFER"}, --Moonkin Form
		{[18]="MELEE_BUFFER"}, --Leader of the Pack -- Only considered if the druid isn't placed in a tanking group
		{[20]="TANK_BUFFER"}   --Tree of Life
	},
	["SHAMAN"] = {
		{}, --shaman are already melee buffers by default so it doesn't matter
		{},
		{[16]="MANA_BATTERY"} --Mana Tide Totem
	},
	["MAGE"] = {
		{},
		{},
		{}
	},
	["WARLOCK"] = {
		{},
		{[2]="TANK_BUFFER"}, --Improved Imp -- These warlocks get priority for tank groups
		{}
	},
	["ROGUE"] = {
		{},
		{},
		{}
	},
	["HUNTER"] = {
		{[17]="RANGE_BUFFER"}, --Ferocious Inspiration -- Melee will get put in this group also if there are no available melee groups or other ranged for this group
		{[17]="RANGE_BUFFER"}, --Trueshot Aura -- Melee will get put in this group also if there are no available melee groups or other ranged for this group
		{}
	},
	["PRIEST"] = {
		{},
		{},
		{[13]="TANK_BUFFER",[21]="MANA_BATTERY"} --VE and VT -- VT is considered first for group placement
	},
	["PALADIN"] = {
		{},
		{[1]="TANK_BUFFER"}, --Improved Devotion Aura -- Only matters if the pally is not a tank
		{}
	},
}

local currentRaidGroupIndexByName = {}

local currentRaidGroupRolesByIndex = {}

--list of subgroups by raid index
local currentRaidGroupPlacement = {}

local optimalRaidGroupPlacement = {}

--used for the "start over" button if an auto-arrange is forced to stop (someone leaves the raid etc)
local lastAction = {false, ""} -- [1] is true if the last action was a raid restore, and if so, [2] will be the name of the saved raid

local outdatedCheck = false

local delayedActionInProgress = false

local lastRaidSetup = {}

local groupFullErr = false

local resetErrorTimer = 0

local function cout(msg)
	if(DEFAULT_CHAT_FRAME and not GrOM_Vars.Silent) then
		DEFAULT_CHAT_FRAME:AddMessage(loc.outputprefix .. msg, 0.0, 1.0, 0.0, 1.0);	
	end
end

local function dout(msg)
	if DEFAULT_CHAT_FRAME then
		DEFAULT_CHAT_FRAME:AddMessage("GOM DEBUG: " .. msg, 1.0, 0.0, 0.0, 1.0);	
	end
end

local function ValidateCheckBoxes()
	GOMaticOverrideRemote:SetChecked(GrOM_Vars.LocalOverridesRemote)
	GOMaticSilence:SetChecked(GrOM_Vars.Silent)
	GOMaticSure:SetChecked(GrOM_Vars.AlwaysSure)
end

local function GetPVEorPVPUName(unit)
	local name, realm = UnitName(unit)
	
	if not name then
		return nil
	end
	
	if realm then
		name = name .. "-" .. realm
	end
	
	return name
end

--ty to Aquendyn for this function
local function GetCmd(msg)
	if msg then
 		local a,b,c=strfind(msg, "(%S+)");
 		if a then
 			return c, strsub(msg, b+2);
 		else	
 			return "";
 		end
 	end
end

local function tremovebyval(tab, val)
	for k,v in pairs(tab) do
		if(v==val) then
			table.remove(tab, k)
			return true
		end
	end
	return false
end

local function BuildIndexByNameTable()
	for i=1, 40 do 
		currentRaidGroupIndexByName[GetRaidRosterInfo(i) or "-"]=i
	end
end

local PingReplies = {}

local function PingFrame_OnEvent()	
	if arg3 == "WHISPER" then
		if arg1 == "GOMPINGR" then
			table.insert(PingReplies, arg4)
			if arg2 ~= GrOM.Version_String then
				cout(arg4 .. ": " .. arg2 .. "**")
			else
				cout(arg4 .. ": " .. arg2)
			end
		end
	end
end

local PingFrameDelay = 3
local PingFrameStartTime = 0

local function PingFrame_OnUpdate()
	if PingFrameStartTime + PingFrameDelay < time() then		
		if GetNumRaidMembers() > 1 then
			for i=1, 40 do
				n = (GetRaidRosterInfo(i))
				if n then
					if not tremovebyval(PingReplies, n) then
						cout(n .. ": " .. loc.notinstalled)
					end
				end
			end
		end
		delayedActionInProgress = false
		GrOM.UpdateButtons()
		this:UnregisterEvent("CHAT_MSG_ADDON")
		this:SetScript("OnEvent", nil)
		this:SetScript("OnUpdate", nil)
		GOMatic_PingFrame = nil
	end
end

local function CreatePingFrame()
	PingReplies = {UnitName("player")}

	PingFrameStartTime = time()
	
	delayedActionInProgress = true
	GrOM.UpdateButtons()
	local f = CreateFrame("Frame","GOMatic_PingFrame")
	f:SetScript("OnEvent", PingFrame_OnEvent)
	f:SetScript("OnUpdate", PingFrame_OnUpdate)
	f:RegisterEvent("CHAT_MSG_ADDON")
	f:Show()
end	

local function FindMemberID(n)
	if GetNumRaidMembers() > 1 then
		for i=1, 40 do
			if n == GetRaidRosterInfo(i) then
				return i
			end
		end
	end
	
	return false
end

function GrOM.RSCommandHandler(msg)
	if InCombatLockdown() then
		return
	end

	local cmd, sc = GetCmd(msg)	
	
	if not (cmd or sc) then
		return
	end
	
	BuildIndexByNameTable()
	
	local i1, i2 = currentRaidGroupIndexByName[cmd], currentRaidGroupIndexByName[sc]
	
	if i1 and i2 then
		SwapRaidSubgroup(i1, i2)
	end
end

function GrOM.RMCommandHandler(msg)
	if InCombatLockdown() then
		return
	end

	local cmd, sc = GetCmd(msg)
	
	sc = tonumber(sc)
	
	if not (cmd and sc) then
		return
	end
	
	if sc < 1 or sc > 8 then
		return
	end
	
	BuildIndexByNameTable()
	
	local i = currentRaidGroupIndexByName[cmd]
	
	if i then
		SetRaidSubgroup(i, sc)
	end
end

function GrOM.Ping()
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		
		CreatePingFrame()
		SendAddonMessage("GOMPING", tostring(GrOM.Version), "RAID")
end

function GrOM.Cancel()	
	delayedActionInProgress = false
	GrOM.UpdateButtons()

	if GOMatic_ArrangementFrame and GOMatic_ArrangementFrame:IsVisible() then
		GOMatic_ArrangementFrame:SetScript("OnUpdate", nil)
		GOMatic_ArrangementFrame:SetScript("OnEvent", nil)
		GOMatic_ArrangementFrame = nil		
		cout(loc.cancelled)
	end
	
	if GOMatic_TalentRequestFrame and GOMatic_TalentRequestFrame:IsVisible() then
		GOMatic_TalentRequestFrame:SetScript("OnEvent", nil)
		GOMatic_TalentRequestFrame:UnregisterEvent("CHAT_MSG_ADDON")
		GOMatic_TalentRequestFrame:UnregisterEvent("INSPECT_TALENT_READY")
		GOMatic_TalentRequestFrame:SetScript("OnUpdate", nil)
		GOMatic_TalentRequestFrame = nil
		cout(loc.cancelled)
	end
	
	if GOMatic_PingFrame and GOMatic_PingFrame:IsVisible() then
		GOMatic_PingFrame:UnregisterEvent("CHAT_MSG_ADDON")
		GOMatic_PingFrame:SetScript("OnEvent", nil)
		GOMatic_PingFrame:SetScript("OnUpdate", nil)
		GOMatic_PingFrame = nil
	end	
end

function GrOM.SlashCommandHandler(msg)
	local cmd, sc = GetCmd(msg)

	if GetNumRaidMembers() < 2 then
		cout(loc.nopointerr)
		return
	end

	if cmd and string.lower(cmd) == loc.pingcmd then
		GrOM.Ping()
	elseif cmd and string.lower(cmd) == loc.guicmd then
		GrOM_Vars.ShowGUI = not GrOM_Vars.ShowGUI
		
		if GrOM_Vars.ShowGUI then
			cout(loc.guishown)
			if GetNumRaidMembers() > 1 then
				GOMatic:Show()
				GrOM.UpdateButtons()
			end
		else
			cout(loc.guihidden)
			GOMatic:Hide()
		end
	elseif cmd and string.lower(cmd) == loc.silentcmd then
		GrOM_Vars.Silent = not GrOM_Vars.Silent
		cout(loc.unsilenced)
	elseif cmd and string.lower(cmd) == loc.surecmd then
		GrOM_Vars.AlwaysSure = not GrOM_Vars.AlwaysSure
		cout(GrOM_Vars.AlwaysSure and loc.sureon or loc.sureoff)
	elseif cmd and string.lower(cmd) == loc.cancelcmd then
		GrOM.Cancel()
	elseif cmd and string.lower(cmd) == loc.savecmd then
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		if sc and sc ~= "" then			
			if GrOM_Vars.SavedRaidLayouts[sc] then
				GrOM.SaveName = sc
				StaticPopup_Show("GOMatic_DO_SAVE", sc)
			else
				GrOM.SaveRaid(sc)
			end
		else
			cout(loc.mustenternameerr)
		end
	elseif cmd and string.lower(cmd) == loc.restorecmd then
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		if sc then
			local n = GrOM_Vars.SavedRaidLayouts[sc]
			if n then				
				lastAction = {true, sc}
				GrOM.RestoreRaid(n)
			else
				cout(loc.mustenternameerr)
				cout(loc.thesearegoodnames)
				foreach(GrOM_Vars.SavedRaidLayouts, function(k,v) cout(k) end)
			end
		else
			cout(loc.mustenternameerr)
			cout(loc.thesearegoodnames)
			foreach(GrOM_Vars.SavedRaidLayouts, function(k,v) cout(k) end)
		end
	elseif cmd and string.lower(cmd) == loc.autocmd then
		if delayedActionInProgress then
			cout(loc.pleasewaiterr)
			return
		end
		lastAction = {false, ""}
		GrOM.StartArrange()
	else
		cout(loc.help)
	end
	
	ValidateCheckBoxes()
end

function GrOM.AutoClick()
	if delayedActionInProgress then
		cout(loc.pleasewaiterr)
		return
	end
	lastAction = {false, ""}
	GrOM.StartArrange()
end

function GrOM.RolesToString(roles)
	local msg = "{"
	
	for i=1, 11 do
		local x = (roles[i]) and "true, " or "false, "
		msg = msg .. x
	end
	local x = (roles[12]) and "true}" or "false}"
	msg = msg .. x
	
	return msg
end

function GrOM.OnEvent()
	if event == "VARIABLES_LOADED" then
		hooksecurefunc("NotifyInspect", function() GrOM.InspectTainted = true end) --make sure that noone else calls notifyinspect between the time we do and receiving talents
		
		-------------------------------------
		--update old variables
		if GOMatic_RolesByNameCache then
			GrOM_Vars.RolesByNameCache = GOMatic_RolesByNameCache
		end
		
		if GOMatic_SavedRaidLayouts then
			GrOM_Vars.SavedRaidLayouts = GOMatic_SavedRaidLayouts
		end
		
		if GOMatic_AlwaysSure then
			GrOM_Vars.AlwaysSure = GOMatic_AlwaysSure
		end
		
		if GOMatic_Silent then
			GrOM_Vars.Silent = GOMatic_Silent
		end
		
		if GOMatic_ShowGUI then
			GrOM_Vars.ShowGUI = GOMatic_ShowGUI
		end
			
		if GOMatic_LocalOverridesRemote then
			GrOM_Vars.LocalOverridesRemote = GOMatic_LocalOverridesRemote
		end
		
		GOMatic_RolesByNameCache = nil
		GOMatic_SavedRaidLayouts = nil
		GOMatic_AlwaysSure = nil
		GOMatic_Silent = nil
		GOMatic_ShowGUI = nil
		-------------------------------------
		
		ValidateCheckBoxes()
		cout(GrOM.Version_String .. loc.loaded)
	elseif event == "PLAYER_REGEN_DISABLED" then
		GrOM.UpdateButtons(1)
	elseif event == "PLAYER_REGEN_ENABLED" then
		GrOM.UpdateButtons(0)
	elseif event == "RAID_ROSTER_UPDATE" then
		SendAddonMessage("GOMVER", tostring(GrOM.Version), "RAID")
		if GetNumRaidMembers() < 2 then
			this:Hide()
		else
			this:Show()
			GrOM.UpdateButtons()
		end
		if not GrOM_Vars.ShowGUI then
			this:Hide()
		end
	elseif event == "CHAT_MSG_ADDON" then		
		if arg3 == "RAID" then
			if arg1 == "GOMPING" then
				SendAddonMessage("GOMPINGR", GrOM.Version_String, "WHISPER", arg4)
			elseif arg1 == "GOMVER" then
				if tonumber(arg2) and tonumber(arg2) > GrOM.Version and GrOM.Version >= 1 then
					if not (outdatedCheck or InCombatLockdown() ) then
						StaticPopup_Show("GOMatic_OUTDATED")
						outdatedCheck = true
					end
				end
			elseif arg1 == "GOMTALENT" then
				local myRoles = GetMyRoles()
				if myRoles then
					SendAddonMessage("GOMTALENTR", GrOM.RolesToString(myRoles), "WHISPER", arg4)
				else
					cout(loc.talentserr)
				end
			end
		end
	end
end

function GrOM.OnLoad()
	if GetNumRaidMembers() < 2 then
		this:Hide()
	end

	StaticPopupDialogs["GOMatic_DO_ARRANGE"] = {
		text = loc.doarrangedialogtext,
		button1 = loc.buttonok,		
		button2 = loc.buttoncancel,
		OnAccept = function()			
			GrOM.CreateArrangementFrame()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_ERROR_TOOMANYFAILEDMOVES"] = {
		text = loc.toomanyfailedmovesdialogtext,
		button1 = loc.buttonok,		
		timeout = 30,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_DO_SAVE"] = {
		text = loc.dosavedialogtext,
		button1 = loc.buttonok,		
		button2 = loc.buttoncancel,
		OnAccept = function()
			GrOM.SaveRaid(GrOM.SaveName)
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_AUTO_ABORT"] = {
		text = loc.autoabortdialogtext,
		button1 = loc.buttonstartover,		
		button2 = loc.buttoncancel,
		OnAccept = function()
			GrOM.StartOver()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_DELETE_ALL_SAVES"] = {
		text = loc.deletealldialogtext,
		button1 = loc.buttonok,		
		button2 = loc.buttoncancel,
		OnAccept = function()
			GrOM.DeleteAllSavedRaids()
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}		 
	
	StaticPopupDialogs["GOMatic_OUTDATED"] = {
		text = loc.addonoutdateddialogtext,
		button1 = loc.buttonok,
		timeout = 30,
		whileDead = 1,
		hideOnEscape = 1
	}
	
	StaticPopupDialogs["GOMatic_NEW_SAVE"] = {
		text = loc.newsavedialogtext,
		button1 = loc.buttonok,		
		button2 = loc.buttoncancel,
		hasEditBox = 1,
		maxLetters = 12,
		OnShow = function()
			local editBox = getglobal(this:GetParent():GetName().."EditBox")
			editBox:SetText("")
		end,
		OnAccept = function()
			local editBox = getglobal(this:GetParent():GetName().."EditBox")
			local name = editBox:GetText()
			name = string.gsub(name, " ", "")
			if not name or name == "" then
				cout(loc.mustenternameerr)
				return
			end			
			GOMaticDropdown_DoSaveMenuItem(nil, name)					
		end,
		OnShow = function()
			getglobal(this:GetName().."EditBox"):SetFocus();
		end,
		EditBoxOnEnterPressed = function()
			local editBox = getglobal(this:GetParent():GetName().."EditBox")
			local name = editBox:GetText()
			name = string.gsub(name, " ", "")
			if not name or name == "" then
				cout(loc.mustenternameerr)
				return
			end			
			GOMaticDropdown_DoSaveMenuItem(nil, name)
			this:GetParent():Hide()
		end,
		EditBoxOnEscapePressed = function()
			this:GetParent():Hide()
		end,		
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1
	}	
	
	GOMaticTitleText:SetText("GOM:")
	GOMaticTemplateText:SetText(loc.templatetext)
	GOMaticSave:SetText(loc.savebutton)
	GOMaticRestore:SetText(loc.restorebutton)
	GOMaticAuto:SetText(loc.autobutton)
	GOMaticHide:SetText(loc.hidebutton)
	GOMaticMore:SetText(loc.morebutton)
	GOMaticLess:SetText(loc.lessbutton)
	GOMaticPing:SetText(loc.pingbutton)
	GOMaticCancel:SetText(loc.buttoncancel)
	GOMaticOverrideRemoteText:SetText(loc.overridebutton)
	GOMaticSilenceText:SetText(loc.silencebutton)
	GOMaticSureText:SetText(loc.surebutton)
		
	this:RegisterEvent("PLAYER_REGEN_DISABLED")
	this:RegisterEvent("PLAYER_REGEN_ENABLED")
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("CHAT_MSG_ADDON")
	this:RegisterEvent("RAID_ROSTER_UPDATE")
	
	SlashCmdList["GROUPOMATIC"] = GrOM.SlashCommandHandler
	SLASH_GROUPOMATIC1 = "/groupomatic"
	SLASH_GROUPOMATIC2 = "/gom"
	
	SlashCmdList["GROUPOMATIC_RAID_MOVE"] = GrOM.RMCommandHandler
	SLASH_GROUPOMATIC_RAID_MOVE1 = "/raidmove"
	SLASH_GROUPOMATIC_RAID_MOVE2 = "/rm"
	
	SlashCmdList["GROUPOMATIC_RAID_SWAP"] = GrOM.RSCommandHandler
	SLASH_GROUPOMATIC_RAID_SWAP1 = "/raidswap"
	SLASH_GROUPOMATIC_RAID_SWAP2 = "/rs"
end

local function GetMyRoles(u)	
	local mainRole = {0,0,0,0,0} --counter: tank/heal/melee/ranged/spell
	local myClass = select(2, UnitClass("player"))	
	if u then
		myClass = select(2, UnitClass(u))
		u = true
	end
	local roles = universalClassRoles[myClass]
	local x = talentsToMainRolesByClass[myClass]

	if GetNumTalentTabs(u) ~= 3 then
		return false
	end
	
	if x then
		if GetNumTalents(1,u) ~= getn(x[1]) or GetNumTalents(2,u) ~= getn(x[2]) or GetNumTalents(3,u) ~= getn(x[3]) then
			return false
		end
	end	
	
	if not x then
		--player is a pure class, just find special roles
		mainRole = nil
		
		for i=1, 3 do    
			for j=1, GetNumTalents(i,u) do
				local _, _, _, _, rank, maxRank = GetTalentInfo(i,j,u)	
				--this finds special roles, like "tank_buffer" for pallies with imp devo or locks with imp imp. generally these roles are simply "preferred" ie those players will get picked first to be in the tank groups		
				if rank == maxRank then
					local r = talentsToSpecialRolesByClass[myClass][i][j]
					if r then
						roles[roleIndex[r] ] = true
					end
				end
			end
		end
	else
		--player is a hybrid class, find main role and special roles
		for i=1, 3 do    
			for j=1, GetNumTalents(i,u) do
				local _, _, _, _, rank, maxRank = GetTalentInfo(i,j,u)
				
				if rank == maxRank then
					--this tries to figure out the primary role of the player by counting the number of tanking vs healing vs dps talents they have			
					mainRole[x[i][j] ] = mainRole[x[i][j] ] + 1
					--this finds special roles, like "tank_buffer" for pallies with imp devo or locks with imp imp. generally these roles are simply "preferred" ie those players will get picked first to be in the tank groups
					local r = talentsToSpecialRolesByClass[myClass][i][j]
					if r then
						roles[roleIndex[r] ] = true
					end
				end
			end
		end	
	end
	
	if mainRole then
		local roleHighest, myMainRole = 0, 1
				
		for a=1, 5 do
			if mainRole[a] > roleHighest then
				roleHighest = mainRole[a]
				myMainRole = a
			end
		end
			
		roles[roleIndex[({"TANK", "HEALER", "MELEE_DPS", "RANGE_DPS", "SPELL_DPS"})[myMainRole] ] ] = true
	end
	
	return roles
end

local function GetAllRaidIDs()
	local allIDs = false

	for i=1, 40 do
		if GetRaidRosterInfo(i) then
			if not allIDs then
				allIDs = {[1]=i}
			else
				table.insert(allIDs, i)
			end
		end
	end
	
	return allIDs
end

local function FillInEmptyRoles(displayIfAnyWereEmpty) --if this is true DON'T display if any were empty
	local wereEmpty = false

	for i=1, 40 do
		if not currentRaidGroupRolesByIndex[i] and UnitExists("raid"..i) then
			currentRaidGroupRolesByIndex[i] = GrOM_Vars.RolesByNameCache[GetPVEorPVPUName("raid"..i)] or defaultClassRoles[select(2, UnitClass("raid"..i))]
			wereEmpty = true
		end
	end
	
	if wereEmpty and not displayIfAnyWereEmpty then
		cout(loc.filledinunknownroleswithdefaultsrunping)
	end
end

local function ArrangeManager()
	delayedActionInProgress = false
	GrOM.UpdateButtons()

	optimalRaidGroupPlacement = {}

	FillInEmptyRoles()

	local optimalSetup = GrOM.Arrange()
	
	if not optimalSetup then
		return
	end
	
	local g = 1;
	
	local group = optimalSetup[g]

	while group and group ~= {} do
		for i=1, 5 do
			if group[i] then
				optimalRaidGroupPlacement[group[i] ] = g;
			end
		end
		g = g + 1
		group = optimalSetup[g]

	end		

	if not GrOM_Vars.AlwaysSure then
		StaticPopup_Show("GOMatic_DO_ARRANGE")
	else		
		GrOM.CreateArrangementFrame()
	end
end

function GrOM.StartOver()
	if lastAction[1] then
		local n = GrOM_Vars.SavedRaidLayouts[lastAction[2]]
		if n then				
			GrOM.RestoreRaid(n)
		end
	else
		GrOM.StartArrange()
	end
end

local function BuildCurrentPlacementTable()
	currentRaidGroupPlacement = {}

	for i=1, 40 do
		local x = select(3, GetRaidRosterInfo(i))
		if x and x > 0 and x < 9 then
			currentRaidGroupPlacement[i] = x
		else
			currentRaidGroupPlacement[i] = nil
		end
	end
end

function GrOM.CreateArrangementFrame()	
	groupFullErr = false

	lastRaidSetup = {}
	
	resetErrorTimer = 0
	
	BuildCurrentPlacementTable()
	
	GOMatic_ArrangementFrameLastUpdate = GetTime()
	GrOM.ArrangementFrameBreakCounter = 0
	
	delayedActionInProgress = true
	GrOM.UpdateButtons()
	local f = CreateFrame("Frame","GOMatic_ArrangementFrame")	
	f:SetScript("OnEvent", GOMatic_ArrangementFrame_OnEvent)
	f:SetScript("OnUpdate", GOMatic_ArrangementFrame_OnUpdate )
	f:RegisterEvent("CHAT_MSG_SYSTEM")
	f:Show()
end

local function IsValidSpec(spec)
	if type(spec) ~= "table" then
		return false
	end
	
	if getn(spec) ~= 12 then
		return false
	end	

	for i=1, 12 do
		if type(spec[i])~= "boolean" then
			return false
		end
	end
	
	return spec[roleIndex["TANK"]] or spec[roleIndex["HEALER"]] or spec[roleIndex["MELEE_DPS"]] or spec[roleIndex["RANGE_DPS"]] or spec[roleIndex["SPELL_DPS"]]
end

local function PlayerRespec(s1, s2)
	local msg = loc.playerhasrespecced

	if s2[roleIndex["TANK"]] and not s1[roleIndex["TANK"]] then
		msg = msg .. loc.spectank
	elseif s2[roleIndex["HEALER"]] and not s1[roleIndex["HEALER"]] then
		msg = msg .. loc.spechealer
	elseif (s2[roleIndex["MELEE_DPS"]] or s2[roleIndex["RANGE_DPS"]] or s2[roleIndex["SPELL_DPS"]]) and not (s1[roleIndex["MELEE_DPS"]] or s1[roleIndex["RANGE_DPS"]] or s1[roleIndex["SPELL_DPS"]]) then
		msg = msg .. loc.specdps
	else
		return nil
	end
	
	return msg
end

local function GetMaxGroups()
	local x = GetNumRaidMembers() / 5
	return math.ceil(x)
end

function GrOM.RemoveFromCache(n)
	GrOM_Vars.RolesByNameCache[n] = nil
end

local raidInspectionIndex = 1
local doneInspecting = false

function GrOM.TalentRequest_OnEvent()
	if event == "CHAT_MSG_ADDON" then
		if arg3 == "WHISPER" and arg1 == "GOMTALENTR" then		
			GrOM.SpecRecieved = {}
			RunScript("GrOM.SpecRecieved = " .. arg2)
			local spec = GrOM.SpecRecieved
			
			if not IsValidSpec(spec) then
				return
			end
			
			if currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[arg4] ] then
				return
			end
						
			currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[arg4] ] = spec
			
			if GrOM_Vars.RolesByNameCache[arg4] then
				local respec = PlayerRespec(GrOM_Vars.RolesByNameCache[arg4], spec)
				if respec then
					cout(string.format(respec, arg4))
				end 
			end
	
			GrOM_Vars.RolesByNameCache[arg4] = spec
		end
	elseif event == "INSPECT_TALENT_READY" then
		if GrOM_Vars.LocalOverridesRemote then
			return
		end
		local u = "raid" .. raidInspectionIndex
		if GrOM.InspectTainted then

			if (not UnitIsDead("player") ) and UnitExists(u) and UnitIsVisible(u) and (not UnitIsUnit(u, "player") ) then --UnitInRange(u)
				NotifyInspect(u)
			else
				while raidInspectionIndex < 40 do
					raidInspectionIndex = raidInspectionIndex + 1
					u = "raid" .. raidInspectionIndex
				
					if (not UnitIsDead("player") ) and UnitExists(u) and UnitIsVisible(u) and (not UnitIsUnit(u, "player") ) then  --UnitInRange(u)
						GOMatic_TalentRequestFrame:RegisterEvent("INSPECT_TALENT_READY")
						NotifyInspect(u)
						GrOM.InspectTainted = false
						return
					end
				end
			end
		
			GrOM.InspectTainted = false
			return
		end
	
		GOMatic_TalentRequestFrame:UnregisterEvent("INSPECT_TALENT_READY")
		
		if GetTime() - GrOM.TalentRequestStartTime > 10 then
			if raidInspectionIndex == 10 then
				cout("25%")
			elseif raidInspectionIndex == 20 then
				cout("50%")
			elseif raidInspectionIndex == 30 then
				cout("75%")				
			end
		end	

		local spec = GetMyRoles(u)
		local name = GetPVEorPVPUName(u)
		
		if spec and IsValidSpec(spec) then
			if currentRaidGroupIndexByName[name] then
				currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[name] ] = spec
				
				if GrOM_Vars.RolesByNameCache[name] then
					local respec = PlayerRespec(GrOM_Vars.RolesByNameCache[name], spec)
					if respec then
						cout(string.format(respec, name))
					end 
				end
	
				GrOM_Vars.RolesByNameCache[name] = spec
			end
		end				

		raidInspectionIndex = raidInspectionIndex + 1
		
		if raidInspectionIndex == 41 then
			raidInspectionIndex = 0
			doneInspecting = true
			return
		end
		
		if (not UnitIsDead("player") ) and UnitExists(u) and UnitIsVisible(u) and (not UnitIsUnit(u, "player") ) then  --UnitInRange(u)
			GOMatic_TalentRequestFrame:RegisterEvent("INSPECT_TALENT_READY")
			NotifyInspect(u)
			GrOM.InspectTainted = false
		elseif raidInspectionIndex < 40 then
			while raidInspectionIndex < 40 do
				raidInspectionIndex = raidInspectionIndex + 1
				u = "raid" .. raidInspectionIndex
			
				if (not UnitIsDead("player") ) and UnitExists(u) and UnitIsVisible(u) and (not UnitIsUnit(u, "player") ) then  --UnitInRange(u)
					GOMatic_TalentRequestFrame:RegisterEvent("INSPECT_TALENT_READY")
					NotifyInspect(u)
					GrOM.InspectTainted = false
					return
				end
			end
			
			raidInspectionIndex = 0
			doneInspecting = true
			return
		end
	end
end

local function TalentRequest_OnUpdate()
	if GrOM.TalentRequestStartTime + GrOM.TalentRequestDelayMinimum < GetTime() then
		if not GrOM_Vars.LocalOverridesRemote then
			 if not (doneInspecting or GrOM.TalentRequestStartTime + GrOM.TalentRequestDelayMaximum < GetTime()  ) then
			 	return
			 end
		end
		
		ArrangeManager()
		GOMatic_TalentRequestFrame:SetScript("OnEvent", nil)
		GOMatic_TalentRequestFrame:UnregisterEvent("CHAT_MSG_ADDON")
		GOMatic_TalentRequestFrame:UnregisterEvent("INSPECT_TALENT_READY")
		GOMatic_TalentRequestFrame:SetScript("OnUpdate", nil)
		GOMatic_TalentRequestFrame = nil
	end
end

local function CreateTalentRequestFrame()
	raidInspectionIndex = 1
	doneInspecting = false
	GrOM.TalentRequestStartTime = GetTime()

	delayedActionInProgress = true
	GrOM.UpdateButtons()
	local f = CreateFrame("Frame","GOMatic_TalentRequestFrame")
	f:SetScript("OnUpdate", TalentRequest_OnUpdate)
	f:SetScript("OnEvent", GrOM.TalentRequest_OnEvent)
	f:RegisterEvent("CHAT_MSG_ADDON")	
	f:Show()
	SendAddonMessage("GOMTALENT", tostring(GrOM.Version), "RAID")

	
	if not GrOM_Vars.LocalOverridesRemote then
		f:RegisterEvent("INSPECT_TALENT_READY")
		local u = ""
		for i=1, 40 do
			u = "raid" .. i
			if (not UnitIsDead("player") ) and UnitExists(u) and UnitIsVisible(u) and (not UnitIsUnit(u, "player") ) then  --UnitInRange(u)
				raidInspectionIndex = i
				GOMatic_TalentRequestFrame:RegisterEvent("INSPECT_TALENT_READY")
				NotifyInspect(u)
				GrOM.InspectTainted = false
				return
			end
		end
		raidInspectionIndex = 0
		doneInspecting = true
	end
end

local function BuildRolesByIndexTable()
	for i=1, 40 do
		currentRaidGroupRolesByIndex[i] = false
	end
end

local function FindWorkingGroup(optimalSetup)
	local group = -1
	
	if GetNumRaidMembers() == 0 then
		return -1
	end
	
	for i=1, GetMaxGroups() do
		if (not optimalSetup[i][1]) then
			group = i
			break
		end
	end
	
	if group == -1 then
		for i=1, 8 do
			if not optimalSetup[i][1] then
				return -1
			end
			if getn(optimalSetup[i]) < 5 then
				group = i
				break
			end
		end
	end
	
	return group
end

function GrOM.StartArrange()
	if not IsRaidLeader() then
		cout(loc.notraidleadererror)
		return
	end
	
	GrOM.ARRANGE_BREAK = 0
	
	BuildIndexByNameTable()	
	BuildRolesByIndexTable()
	local myRoles = GetMyRoles()
	if not myRoles then
		cout(loc.talentserr)
		myRoles = defaultClassRoles[select(2,UnitClass("player"))]
	end
	currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[UnitName("player")] ] = myRoles
	
	cout(loc.requestingtalents)	
	
	CreateTalentRequestFrame()	
end

--thanks to Mikk for this
local function tcount(tab)
	local n=0
	
	for _ in pairs(tab) do
		n=n+1
	end

	return n
end


local function IsGroupFull(group)
	local n = 0
	
	for i=1, 40 do
		if currentRaidGroupPlacement[i] and currentRaidGroupPlacement[i] == group then
			n = n + 1
		end
	end
		
	return n == 5
end

local function FindIDToMoveToGroup(group)
	if group == -1 then
		return nil
	end
	
	for i=1, 40 do
		local currentGroup = currentRaidGroupPlacement[i]
		local destGroup = optimalRaidGroupPlacement[i]
		
		if currentGroup and currentGroup > 0 and currentGroup < 9 and destGroup and destGroup ~= currentGroup and destGroup > 0 and destGroup < 9 and destGroup == group then
			return i
		end
	end		
	
	return nil
end

local function FindEmptySlot()
	for i=1, 8 do
		if not IsGroupFull(i) then			
			local x = FindIDToMoveToGroup(i)
			if x then
				return i, x
			end
		end
	end
		
	return -1, nil
end

local function ValidateTemplate(template)

	if type(template) ~= "table" then
		return false
	end

	if getn(template) ~= 3 then
		return false
	end

	if type(template[1]) ~= "string" then
		return false
	end

	if template[1] == "" then
		return false
	end

	if type(template[2]) ~= "table" then
		return false
	end

	if type(template[3]) ~= "table" then
		return false
	end

	local fail = false
	
	foreachi(template[2], function(i,v) if not ( (type(v)=="string") or (type(v)=="table") ) then fail = true end end)
	foreachi(template[3], function(i,v) if not ( (type(v)=="string") or (type(v)=="table") ) then fail = true end end)
	
	return not fail
end

local function ValidateGroups(OKGroups)
	if type(OKGroups) ~= "table" then
		return false
	end

	if getn(OKGroups) < 1 or getn(OKGroups) > 8 then
		return false
	end

	for i = 1, getn(OKGroups) do
		local x = OKGroups[i]
		
		if x then
			x = tonumber(x)
			if not x or x < 1 or x > 8 then
				return false
			else
				OKGroups[i] = x
			end
		end
	end

	return OKGroups
end

local function myTFind(tab, i)
	for k, v in pairs(tab) do
		if v == i then
			return true
		end
	end

	return false
end	

--class, prefSpec, requirePref, ignoreSpec, loopWhile
local function ValidateTemplateTable(t)
	if type(t) ~= "table" then
		return false
	end
	
	if getn(t) < 1 or getn(t) > 5 then
		return false
	end
	
	if t[1] then
		if type(t[1]) ~= "string" then
			return false
		end
		
		if not defaultClassRoles[t[1] ] then
			return false
		end
	end
	
	if not t[2] then
		return false
	end
	
	if type(t[2]) ~= "string" then
		return false
	end
	
	if not roleIndex[t[2] ]  then
		return false
	end
	
	if t[4] and (not roleIndex[t[4] ] ) then
		return false
	end
	
	return true
end

function GrOM.DisplayCurrAndDest()
	for i=1, 40 do
		currentGroup = currentRaidGroupPlacement[i]
		destGroup = optimalRaidGroupPlacement[i]
		local msg = ""
		if currentGroup then msg = currentGroup end
		if destGroup then msg = msg .. "     " .. destGroup end
		
		dout(msg)
	end
end

local function FindUnmovedID(ignoreGroup)
	local raidIDToMove, currentGroup, destGroup = nil, nil, nil
	
	for i=1, 40 do
		currentGroup = currentRaidGroupPlacement[i]
		destGroup = optimalRaidGroupPlacement[i]

		if currentGroup and currentGroup > 0 and currentGroup < 9 and (not (ignoreGroup and currentGroup == ignoreGroup)) and destGroup and destGroup ~= currentGroup and destGroup > 0 and destGroup < 9 then
			raidIDToMove = i
			break
		end
	end
	
	return raidIDToMove, currentGroup, destGroup
end

--return 41 if a complete match, raid id if a match except for spec AND requirePref is false, or false if not a good match
local function DoesIDMatchClassAndSpec(ID, class, prefSpec, requirePref, ignoreSpec)
	if type(currentRaidGroupRolesByIndex[ID]) ~= "table" or not IsValidSpec(currentRaidGroupRolesByIndex[ID]) then
		return false
	end
	
	local realSpec, realClass = currentRaidGroupRolesByIndex[ID], select(2, UnitClass("raid"..ID))
	
	local doesMatch = 41
	
	if class and realClass ~= class then
		return false
	end
	
	if not realSpec[prefSpec] then		
		if requirePref then
			return false
		end
	
		doesMatch = ID			
	end
	
	if ignoreSpec and realSpec == ignoreSpec then
		return false
	end	
	
	return doesMatch
end

local function FindInGroup(group, spec)
	for i = 1, getn(group) do
		if currentRaidGroupRolesByIndex[group[i] ][roleIndex[spec] ] then
			return true
		end
	end
	
	return false
end

function GrOM.Arrange(optimalSetup, unassignedMembers)
	if GrOM.ARRANGE_BREAK and GrOM.ARRANGE_BREAK > 100 then
		dout("Bad user template: Infinite loop terminated. Please select another template or use the default.")
		return false
	end
	
	local optimalSetup = optimalSetup or {{},{},{},{},{},{},{},{}}
		
	local unassignedMembers = unassignedMembers or GetAllRaidIDs()	
	
	local x = FindWorkingGroup(optimalSetup)

	if x == -1 or (not unassignedMembers[1]) then
		return optimalSetup
	end
	
	local group = optimalSetup[x]
		
	local match = false
	
	local class, prefSpec, requirePref, ignoreSpec = nil, nil, false, nil

	local lastMatch, lastIndex = -1, -1
	
	local usePreviousGroup = false
	
	local function HandleMatchup(i, v)
		if i == 1 then
			lastMatch = -1
			match = false
		end
		
		if not v then
dout("v nil")
			match = false
			return
		end
		
		local isMatch = DoesIDMatchClassAndSpec(v, class, prefSpec, requirePref, ignoreSpec)
		
		if isMatch then			
			if isMatch == 41 then
				match = true
				table.remove(unassignedMembers, i)
				if usePreviousGroup then
					table.insert(optimalSetup[x-1], v)
				else
					table.insert(group, v)
				end
			
				return true
			elseif lastMatch == -1 then
					lastMatch = v
					lastIndex = i
			end
		end
						
		if i == getn(unassignedMembers) and (not match) and lastMatch > 0 then
			match = true
			table.remove(unassignedMembers, lastIndex)
			if usePreviousGroup then
				table.insert(optimalSetup[x-1], lastMatch)
			else
				table.insert(group, lastMatch)
			end
			
			return true
		end
		
		--this shouldn't ever happen
		if i == getn(unassignedMembers) and match then
dout("end still match")
			match = false
		end
	end
	
	local function myForeachi(tab, func)
		if getn(tab) == 0 then
			match = false
		end
		for k, v in pairs(tab) do
			if func(k,v) then return end
		end
	end	                                                                                                 		                                                                                                                                             
	
	--if a template is selected, and it's valid, use it
	local OKGroups = nil
	if GrOM_Vars.userTemplateToUse then
		if not ( GrOM.userTemplates[GrOM_Vars.userTemplateToUse ] and ValidateTemplate(GrOM.userTemplates[GrOM_Vars.userTemplateToUse ]) ) then
			dout("Bad user template. Please select another template or use the default.")
			return false
		end
	
		local template = {}
		
		if not group[1] then
			template = GrOM.userTemplates[GrOM_Vars.userTemplateToUse ][2]
		else
			template = GrOM.userTemplates[GrOM_Vars.userTemplateToUse ][3]
		end
	
		local tc = 0
		while tc < getn(template) and tcount(group) < 5 do
			tc = tc + 1
			if type(template[tc]) == "string" then
				local cmd, sc = GetCmd(template[tc])
				if cmd and sc then
					if cmd == "fail" and not match then
						sc = tonumber(sc)
						if sc and sc > tc then
							tc = sc - 1
						else
							dout("Bad user template. Please select another template or use the default. Aborting. Error at index " .. tc .. ". Usage: fail # (# must be > the current index)")
							return false
						end
					elseif cmd == "go" then
						sc = tonumber(sc)
						if sc and sc > tc then
							tc = sc - 1
						else
							dout("Bad user template. Please select another template or use the default. Aborting. Error at index " .. tc .. ". Usage: go # (# must be > the current index)")
							return false
						end
					elseif cmd == "group" then
						OKGroups = ValidateGroups(strsplit(",", sc))
						if not OKGroups then
							dout("Bad user template. Please select another template or use the default. Aborting. Error at index " .. tc .. ". Usage: group #\[,#\[,#\[,#\[,#\[,#\[,#\[,#\]\]\]\]\]\]\]")
							return false
						end
					elseif cmd == "spec" then
						local _,_,n,g = sc:find("(.+) (%d+)")

						if g then
							g = tonumber(g)
						end										
						
						if g and g > tc and n and roleIndex[n] then
							if FindInGroup(group, n) then
								tc = g - 1
							end							
						else
							dout("Bad user template. Please select another template or use the default. Aborting. Error at index " .. tc .. ". Usage: spec ROLE # (# must be > the current index)")
							return false
						end		
					elseif cmd == "end" then
						tc = getn(template)
					end
				end
			elseif type(template[tc]) == "table" then
				if not ValidateTemplateTable(template[tc]) then					
					dout("Bad user template. Please select another template or use the default. Aborting. Error at index " .. tc .. ". Usage: {class\|nil, prefSpec, requirePref?\[, ignoreSpec\|nil\[, loop?\]\]}")
					return false
				end
				if OKGroups then
					if myTFind(OKGroups, tc) then	
						class, prefSpec, requirePref, ignoreSpec, loopWhile = template[tc][1], template[tc][2], template[tc][3], template[tc][4], template[tc][5]
						if prefSpec then
							prefSpec = roleIndex[prefSpec]
						end
						myForeachi(unassignedMembers, HandleMatchup)
						while loopWhile and tcount(group) < 5 and match do
							myForeachi(unassignedMembers, HandleMatchup)
						end
					end
				else
					class, prefSpec, requirePref, ignoreSpec, loopWhile = template[tc][1], template[tc][2], template[tc][3], template[tc][4], template[tc][5]
					if prefSpec then
						prefSpec = roleIndex[prefSpec]
					end
					myForeachi(unassignedMembers, HandleMatchup)
					while loopWhile and tcount(group) < 5 and match do
						myForeachi(unassignedMembers, HandleMatchup)
					end
				end
				OKGroups = nil
			end
		end

		optimalSetup[x] = group
		return GrOM.Arrange(optimalSetup, unassignedMembers)
	end
		
	
	--no template, use defaults
	if not group[1] then	
		--we're creating a new group
		--if there is a tank available, add it and
			--if there is another tank available, add it too
			--if there is a tree druid, add it
			--if there is a pally that is not a tank and is a "tank buffer" available, add it
			--otherwise if there is a pally that isn't a tank available, add it
			--if there is a warlock that is a "tank buffer" available, add it, otherwise, if there is any other warlock available, add it			
			--stop
		--else if there is a healer available, add it and
			--if there is a mana battery, add it
			--if there is any free "heal buffer" add it
			--add as many other healers as there are free
			--stop
		--else if there is a melee dps available, add it and
			--if there is any melee buffer available, add it
			--find as many melee dps as are available, and add them
			--stop
		--else do the same as above for ranged and then spell dps
		
		
		class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK"], true, nil
		myForeachi(unassignedMembers, HandleMatchup)
		if match then		
			class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK"], true, nil
			myForeachi(unassignedMembers, HandleMatchup)
			--[[tree druids ... i dunno why i thought i needed to do it this way >.<
			if not match then
				class, prefSpec, requirePref, ignoreSpec = "DRUID", roleIndex["TANK_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			elseif x > 1 then
				usePreviousGroup = true
				class, prefSpec, requirePref, ignoreSpec = "DRUID", roleIndex["TANK_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				if match and getn(optimalSetup[x-1]) == 6 then				
					for gc=1, 5 do
						if group[i] and currentRaidGroupRolesByIndex[group[i] ][roleIndex["TANK"] ] then
							table.insert(unassignedMembers,table.remove(group, i))
							break
						end
					end
					for gp=1, 6 do
						if optimalSetup[x-1][i] and currentRaidGroupRolesByIndex[optimalSetup[x-1][i] ][roleIndex["TANK"] ] then
							table.insert(group, table.remove(optimalSetup[x-1], i))
							break
						end
					end					
				end
				usePreviousGroup = false
			end
			--end tree druids]]
			
			class, prefSpec, requirePref, ignoreSpec = "DRUID", roleIndex["TANK_BUFFER"], true, roleIndex["TANK"]
			myForeachi(unassignedMembers, HandleMatchup)
			
			class, prefSpec, requirePref, ignoreSpec = "PALADIN", roleIndex["TANK_BUFFER"], false, roleIndex["TANK"]
			myForeachi(unassignedMembers, HandleMatchup)
			
			class, prefSpec, requirePref, ignoreSpec = "WARLOCK", roleIndex["TANK_BUFFER"], false, nil
			myForeachi(unassignedMembers, HandleMatchup)
		else
			class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEALER"], true, nil
			myForeachi(unassignedMembers, HandleMatchup)
			
			if match then
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MANA_BATTERY"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEAL_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				
				match = true
				while tcount(group) < 5 and match do
					class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEALER"], true, nil
					myForeachi(unassignedMembers, HandleMatchup)
				end
			else
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
				
				if match then
					class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_BUFFER"], true, nil
					myForeachi(unassignedMembers, HandleMatchup)
				
					match = true
					while tcount(group) < 5 and match do
						class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
						myForeachi(unassignedMembers, HandleMatchup)
					end
				else
					class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_DPS"], true, nil
					myForeachi(unassignedMembers, HandleMatchup)
				
					if match then
						class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_BUFFER"], true, nil
						myForeachi(unassignedMembers, HandleMatchup)
				
						match = true
						while tcount(group) < 5 and match do
							class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_DPS"], true, nil
							myForeachi(unassignedMembers, HandleMatchup)
						end
					else
						class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["SPELL_DPS"], true, nil
						myForeachi(unassignedMembers, HandleMatchup)
				
						if match then
							class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["SPELL_BUFFER"], true, nil
							myForeachi(unassignedMembers, HandleMatchup)
				
							match = true
							while tcount(group) < 5 and match do
								class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["SPELL_DPS"], true, nil
								myForeachi(unassignedMembers, HandleMatchup)
							end
						else
							cout(loc.arrangefailederr)							
							return false
						end
					end
				end
			end
		end
	else
		--we're filling in empty space
		--if there is a healer anywhere in the group
			--find any available heal buffers or mana batteries and add them
		--if there is a tank anywhere in the group
			--find any available tanks or tank buffers and add them
		--if there are any melee buffers in the group, add any available melee dps
		--if there are any ranged buffers in the group, add any available ranged dps and then melee dps
		--if there are any spell buffers in the group, add any available spell dps
		if FindInGroup(group, "HEALER") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["HEAL_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
			
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MANA_BATTERY"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end		
		if FindInGroup(group, "TANK") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK_BUFFER"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
			
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["TANK"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end
		if FindInGroup(group, "MELEE_BUFFER") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end
		if FindInGroup(group, "RANGE_BUFFER") then
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["RANGE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end		
		
			match = true
			while tcount(group) < 5 and match do								
				class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], true, nil
				myForeachi(unassignedMembers, HandleMatchup)
			end
		end
		--fill in any remaining spots with whatever is available		
		match = true
		while tcount(group) < 5 and match do								
			class, prefSpec, requirePref, ignoreSpec = nil, roleIndex["MELEE_DPS"], false, nil
			myForeachi(unassignedMembers, HandleMatchup)
		end
	end	
	optimalSetup[x] = group
	
	GrOM.ARRANGE_BREAK = GrOM.ARRANGE_BREAK + 1
	return GrOM.Arrange(optimalSetup, unassignedMembers)
end

function GrOM.RestoreRaid(restoreState)
	resetErrorTimer = 0
	groupFullErr = false
	optimalRaidGroupPlacement = {}
	
	BuildRolesByIndexTable()
	BuildIndexByNameTable()	
	
	local myRoles = GetMyRoles()
	if not myRoles then
		cout(loc.talentserr)
		myRoles = defaultClassRoles[select(2,UnitClass("player"))]
	end
	currentRaidGroupRolesByIndex[currentRaidGroupIndexByName[UnitName("player")] ] = myRoles
	
	FillInEmptyRoles(1)
	
	local optimalSetup, unassignedMembers = {{},{},{},{},{},{},{},{}}, GetAllRaidIDs()
	
	local i, j, k = 0, 0, 0
	
	while i <= getn(unassignedMembers) do
		i = i + 1
		j=0
		while j <= 8 do
			j = j + 1
			k=0
			local z = restoreState[j]
			if not z then
				break
			end
			while k <= getn(z) do
				k = k + 1
				
				local y = z[k]
				if y and currentRaidGroupIndexByName[y] and (unassignedMembers[i] == currentRaidGroupIndexByName[y]) then
					table.insert(optimalSetup[j], table.remove(unassignedMembers, i))
					i = i - 1
					j, k = 9, 6
				end
			end			
		end
	end

	optimalSetup = GrOM.Arrange(optimalSetup, unassignedMembers)
	
	if not optimalSetup then
		return
	end
	
	local g = 1;
	
	local group = optimalSetup[g]
	
	while group and group ~= {} do
		for i=1, 5 do
			if group[i] then
				optimalRaidGroupPlacement[group[i]] = g;
			end
		end
		g = g + 1
		group = optimalSetup[g]
	end		
	
	if not GrOM_Vars.AlwaysSure then
		StaticPopup_Show("GOMatic_DO_ARRANGE")
	else
		GrOM.CreateArrangementFrame()
	end
end

function GrOM.SaveRaid(name)
	GrOM.SaveName = nil

	local raid = {{},{},{},{},{},{},{},{}}
	
	for i=1, 40 do
		local n, _, g = GetRaidRosterInfo(i)
		if n then
			table.insert(raid[g], n)
		end		
	end
	
	GrOM_Vars.SavedRaidLayouts[name] = raid
	
	cout(string.format(loc.raidsaved, name))
end

function GrOM.DeleteAllSavedRaids()
	GrOM_Vars.SavedRaidLayouts = {}

	cout(loc.deletedall)
end

local function CheckForMove()
	local x, y = lastRaidSetup, currentRaidGroupPlacement
	
	if getn(x) ~= getn(y) then
		return true
	end
	
	for i = 1, getn(y) do	
		if not x[i] or x[i] ~= y[i] then
			return true
		end
	end
	
	return false
end

local function DoArrangement()
	if InCombatLockdown() then
		GrOM.Cancel()
		cout(loc.combaterr)
	end

	if resetErrorTimer + GrOM.resetErrorConditionThrottle < GetTime() then
		groupFullErr = false
		lastRaidSetup = {}
	end

	if GrOM.ArrangementFrameBreakCounter > GrOM.ArrangementFrameBreakMaximum then
		if not groupFullErr then
			StaticPopup_Show("GOMatic_ERROR_TOOMANYFAILEDMOVES")
		end
		delayedActionInProgress = false
		GrOM.UpdateButtons()
		GOMatic_ArrangementFrame:SetScript("OnUpdate", nil)
		GOMatic_ArrangementFrame:SetScript("OnEvent", nil)
		GOMatic_ArrangementFrame = nil
	end

	GOMatic_ArrangementFrameLastUpdate = GetTime()	
	
	BuildCurrentPlacementTable()
	
	if not CheckForMove() then
		resetErrorTimer = GetTime()
		return false
	else
		lastRaidSetup = currentRaidGroupPlacement
	end		
	
	local emptySlot, raidIDToMove = FindEmptySlot()			
	
	if raidIDToMove and not groupFullErr then
		SetRaidSubgroup(raidIDToMove, emptySlot)		
		return true
	end
	
	local raidIDToMove, currentGroup, destGroup = FindUnmovedID()
	
	if not raidIDToMove then return false end
	
	local raidIDToMoveB = FindIDToMoveToGroup (currentGroup)
	
	if raidIDToMoveB then
		SwapRaidSubgroup(raidIDToMove, raidIDToMoveB)
	else
		raidIDToMoveB = FindUnmovedID(currentGroup)
		if not raidIDToMoveB then return false end
		
		SwapRaidSubgroup(raidIDToMove, raidIDToMoveB)
	end	
	
	return true
end

function GrOM.RaidIsArranged()
	local isArranged = true
		
	if FindUnmovedID() then
		isArranged = false
	end
	
	if isArranged then
		cout(loc.arrangedone)
	end
	
	return isArranged
end

function GOMatic_ArrangementFrame_OnEvent()
	 if (arg1:match(ERR_RAID_MEMBER_REMOVED_S) or arg1:match(ERR_RAID_YOU_LEFT)) then
	 	StaticPopup_Show("GOMatic_AUTO_ABORT")
	 	delayedActionInProgress = false
	 	GrOM.UpdateButtons()
	 	this:SetScript("OnUpdate", nil)
	 	this:UnregisterEvent("CHAT_MSG_SYSTEM")
	 	this:SetScript("OnEvent", nil)
	 	GOMatic_ArrangementFrame = nil
	 end
	 
	 --remove this once we figure out what's causing the "group full" crap, because this event could concievably trigger if someone tries to invite someone to their full 40 man raid
	 if arg1:match(ERR_GROUP_FULL) then
		groupFullErr = true	 	
		resetErrorTimer = GetTime()
	 end
end

function GOMatic_ArrangementFrame_OnUpdate()
	if (GrOM.ArrangementFrameUpdateThrottle + GOMatic_ArrangementFrameLastUpdate < GetTime()) then
		if GrOM.RaidIsArranged() then
			delayedActionInProgress = false
			GrOM.UpdateButtons()
			this:SetScript("OnUpdate", nil)
			this:UnregisterEvent("CHAT_MSG_SYSTEM")
			this:SetScript("OnEvent", nil)
			GOMatic_ArrangementFrame = nil
			return
		end
	
		if not IsRaidLeader() then
			delayedActionInProgress = false
			GrOM.UpdateButtons()
			this:SetScript("OnUpdate", nil)
			this:UnregisterEvent("CHAT_MSG_SYSTEM")
			this:SetScript("OnEvent", nil)
			GOMatic_ArrangementFrame = nil
			return
		end
		
		local x = (DoArrangement()) and 0 or 1		
		GrOM.ArrangementFrameBreakCounter = GrOM.ArrangementFrameBreakCounter + x
	end
end

GrOM.RestoreVsSave = true

function GrOM.ShowRestoreMenu()
	if delayedActionInProgress then
		cout(loc.pleasewaiterr)
		return
	end
		
	GrOM.RestoreVsSave = true
	ToggleDropDownMenu(1, nil, GOMaticDropDown, "GOMaticRestore", 70, 0)
end

function GrOM.ShowSaveMenu()
	GrOM.RestoreVsSave = false
	ToggleDropDownMenu(1, nil, GOMaticDropDown, "GOMaticSave", 70, 0)
end

function GrOM.AddSaveOrRestoreMenuItem(k, v)
	local info = {}

	info.text = k
	
	if not GrOM.RestoreVsSave then
		info.func = GOMaticDropdown_DoSaveMenuItem
		info.arg1 = nil
		info.arg2 = k
	else
		info.func = GOMaticDropdown_DoRestoreMenuItem
		info.arg1 = k
	end
	
	UIDropDownMenu_AddButton(info)
end

function GrOM.GetCurrentTemplate()
	if not GrOM_Vars.userTemplateToUse then
		return(loc.defaultname)
	end

	local name = GrOM.userTemplates[GrOM_Vars.userTemplateToUse]
	
	if name and type(name) == "table" then
		name = name[1]
		
		if name and type(name) == "string" then
			return name
		end	
	end
	
	return "???"
end

function GOMaticDropdown_DoTemplateMenuItem(key)
	local template = GrOM.userTemplates[key]
	
	if template and ValidateTemplate(template) then
		GrOM_Vars.userTemplateToUse = key
	else
		GrOM_Vars.userTemplateToUse = nil	
	end
	
	UIDropDownMenu_SetSelectedValue(GOMaticTemplateMenu,GrOM.GetCurrentTemplate())
end

function GrOM.AddTemplateMenuItem(key, template)
	local info = {}
	
	local n = "???"
	
	if type(template) == "table" then
		if template[1] and type(template[1]) == "string" then
			n = template[1]
		end
	end
	
	info.text = n
	info.func = GOMaticDropdown_DoTemplateMenuItem
	info.arg1 = key
	UIDropDownMenu_AddButton(info)
end

function GOMaticTemplateDropdown_Initialize()
	local info = {}

	info.text = loc.defaultname
	info.func = GOMaticDropdown_DoTemplateMenuItem
	info.arg1 = nil
	UIDropDownMenu_AddButton(info)
	
	foreach(GrOM.userTemplates, GrOM.AddTemplateMenuItem)
end

function GOMaticDropdown_Initialize()
	local info = {}
	
	if not GrOM.RestoreVsSave then
		info.text = loc.newmenuitem
		info.func = GOMaticDropdown_DoSaveMenuItem
		info.arg1 = true		
		UIDropDownMenu_AddButton(info)
		
		info = {}
		info.text = "   "
		info.isTitle = 1
		UIDropDownMenu_AddButton(info)		
	end	
	
	foreach(GrOM_Vars.SavedRaidLayouts, GrOM.AddSaveOrRestoreMenuItem)
	
	if GrOM.RestoreVsSave then
		info = {}
		info.text = "   "
		info.isTitle = 1
		UIDropDownMenu_AddButton(info)
	
		info = {}
		info.text = loc.deleteallmenuitem		
		info.func = StaticPopup_Show
		info.arg1 = "GOMatic_DELETE_ALL_SAVES"
		UIDropDownMenu_AddButton(info)					
	end	
end

function GOMaticDropdown_DoSaveMenuItem(isNew, sc)
	if isNew then
		StaticPopup_Show("GOMatic_NEW_SAVE")			
		return
	end
	if sc then			
		if GrOM_Vars.SavedRaidLayouts[sc] then
			GrOM.SaveName = sc
			StaticPopup_Show("GOMatic_DO_SAVE", sc)
		else
			GrOM.SaveRaid(sc)
		end
	end
end

function GOMaticDropdown_DoRestoreMenuItem(sc)	
	if sc then
		local n = GrOM_Vars.SavedRaidLayouts[sc]
		if n then				
			lastAction = {true, sc}
			GrOM.RestoreRaid(n)		
		end			
	end
end

function GrOM.UpdateButtons(combat)
	CloseMenus()

	local x = InCombatLockdown()
	if combat then 
		if combat == 1 then
			x = true
		end
	else
		if combat == 0 then
			x = false
		end
	end
	
	if x then
		if delayedActionInProgress then
			GOMaticAuto:Disable()
			GOMaticPing:Disable()
			GOMaticRestore:Disable()
			GOMaticCancel:Disable()
		else
			GOMaticAuto:Disable()
			GOMaticPing:Enable()
			GOMaticRestore:Disable()
			GOMaticCancel:Disable()
		end
	else
		if delayedActionInProgress then
			GOMaticAuto:Disable()
			GOMaticPing:Disable()
			GOMaticRestore:Disable()
			GOMaticCancel:Enable()
		else
			GOMaticAuto:Enable()
			GOMaticPing:Enable()
			GOMaticRestore:Enable()
			GOMaticCancel:Disable()
		end
	end
end

function GrOM.MoreClick()
	GOMaticMore:Hide()
	
	GOMatic:ClearAllPoints()
	local x, y = GOMatic:GetLeft(), GOMatic:GetBottom()
	
	GOMaticLess:Show()
	GOMaticPing:Show()
	GOMaticOverrideRemote:Show()
	GOMaticSilence:Show()
	GOMaticSure:Show()
	GOMaticCancel:Show()
	GOMaticTemplateMenu:Show()
	GOMaticTemplateText:Show()
	
	GOMatic:SetWidth(400)
	
	GOMatic:SetPoint("BOTTOMLEFT", "WorldFrame", "BOTTOMLEFT", x, y)
end

function GrOM.LessClick()
	GOMaticMore:Show()
	
	GOMatic:ClearAllPoints()
	local x, y = GOMatic:GetLeft(), GOMatic:GetBottom()
	
	GOMaticLess:Hide()
	GOMaticPing:Hide()
	GOMaticOverrideRemote:Hide()
	GOMaticSilence:Hide()
	GOMaticSure:Hide()
	GOMaticCancel:Hide()
	GOMaticTemplateMenu:Hide()
	GOMaticTemplateText:Hide()
	
	GOMatic:SetWidth(67)
	
	GOMatic:SetPoint("BOTTOMLEFT", "WorldFrame", "BOTTOMLEFT", x, y)
end

function GrOM.OnCheckBoxClick()
	if this:GetName() == this:GetParent():GetName() .. "OverrideRemote" then
		GrOM_Vars.LocalOverridesRemote = not GrOM_Vars.LocalOverridesRemote
		cout(GrOM_Vars.LocalOverridesRemote and loc.overrideon or loc.overrideoff)
	elseif this:GetName() == this:GetParent():GetName() .. "Silence" then
		GrOM_Vars.Silent = not GrOM_Vars.Silent
		cout(loc.unsilenced)
	elseif this:GetName() == this:GetParent():GetName() .. "Sure" then
		GrOM_Vars.AlwaysSure = not GrOM_Vars.AlwaysSure
		cout(GrOM_Vars.AlwaysSure and loc.sureon or loc.sureoff)
	end
end